#include "xtrack.h"
#include "sattrack.h"
#include "xtrack_basefunc.h"

SAT *add_sun(SAT **sat)
{
  SAT *snw;
  snw=Create_Sat(sat);
  snw->type=sun;
  snw->orbit.height=150000000.*1000.;

  strcpy(snw->satname,"SUN");
  return snw;
}

SAT *add_moon(SAT **sat)
{
  SAT *snw;
  snw=Create_Sat(sat);
  snw->type=moon;
  snw->orbit.height=150000000.;

  strcpy(snw->satname,"MOON");
  return snw;
}

#define ZON
#define MAANn
int add_to_db(DBASE *db,SAT *sat,gboolean on)
{
  SAT *sat_new,*sat_old;
//  if (!sat) return 0;
  if (sat) while (sat->prev) sat=sat->prev;
  db->sat_sel=NULL;
  for (sat_new=sat; sat_new; sat_new=sat_new->next)
  {
    if ((sat_old=Find_Sat(db->sat,sat_new->satname)))
    {
      sat_new->visible=sat_old->visible;
      sat_new->selected=sat_old->selected;
      if (sat_new->selected) db->sat_sel=sat_new;
    }
    if (on) sat_new->visible=TRUE;
    sat_new->db=db;
  }
  while ((db->sat=Remove_Sat(db->sat)));
  sat_new=NULL;
#ifdef ZON
  sat_new=add_sun(&db->sat);
  sat_new->db=db;
#endif
#ifdef MAAN
  sat_new=add_moon(&db->sat);
  sat_new->db=db;
#endif
  if (sat_new)
  {
    sat_new->next=sat;
    sat->prev=sat_new;
  }
  else
  {
    db->sat=sat;
  }

  db->sat_sel=NULL;
  if (!db->sat_sel)
  {
    db->sat_sel=db->sat;
    if (db->sat) db->sat->selected=TRUE;
  }
  return 1;
}
