#include <math.h>
#include <stdlib.h>
#include "xtrack.h"
#include "xtrack_func.h"
#include "defines.h"

extern DBASE *db;

// calc and draw scanline
void calcdraw_sensor(struct tm cur_tm,GtkWidget *wnd,SAT *sat)
{
  EPOINT pos_subsat;
  EPOINT pos_sat;
  EPOINT pos_earth;
  DIRECTION satdir;
  calc_onepos(sat,cur_tm,0,&pos_earth,&pos_sat,&pos_subsat);
//  calceleazim(&pos_subsat,&sat->orbit,&db->refpos,&satdir,db->x_at_disc);
  draw_sensor(wnd,sat,&pos_sat,&pos_earth,TRUE);
}

// calc and draw piece of track between tma and tmb
void draw_track(GtkWidget *wnd,SAT *sat,struct tm tma,struct tm tmb)
{
  EPOINT pos_subsat1,pos_subsat2;
  EPOINT pos_sat;
  EPOINT pos_earth;
  int i=0;
  struct tm tm;
  for (tm=tma; mktime_ntz(&tm) < mktime_ntz(&tmb); tm.tm_min++)
  {
    calc_onepos(sat,tm,0,&pos_earth,&pos_sat,&pos_subsat1);
    if (i) draw_sattrack(wnd,pos_subsat1,pos_subsat2,TRUE,(i==1));
    pos_subsat2=pos_subsat1;
    i++;
  }
  calc_onepos(sat,tmb,0,&pos_earth,&pos_sat,&pos_subsat1);
  draw_sattrack(wnd,pos_subsat1,pos_subsat2,TRUE,TRUE);
}

// calc and draw piece of track
static void draw_trackpiece(GtkWidget *wnd,SAT *sat,struct tm cur_tm,gboolean rgbm)
{
  struct tm tma;
  struct tm tmb;
  int strtmin=-5;
  int stopmin=+40;

  tma=cur_tm; tma.tm_min+=strtmin;
  tmb=cur_tm; tmb.tm_min+=stopmin;
  draw_track(wnd,sat,tma,tmb);
}

// draw one sat on it's position
void draw_onepos(struct tm cur_tm,GtkWidget *wnd,SAT *sat,EPOINT pos_sat,EPOINT pos_earth)
{
  gboolean rgb_flag=TRUE;
  EPOINT pos_subsat=sat->pos;
  DIRECTION satdir=sat->dir;
  draw_sat(wnd,sat,pos_subsat.lon,pos_subsat.lat,rgb_flag);
  calcdraw_sensor(cur_tm,wnd,sat);
  draw_vis(wnd,sat,&pos_subsat,rgb_flag);
  if (sat->selected)
    draw_trackpiece(wnd,sat,cur_tm,TRUE);

  if (sat->selected)
  {
    static int do_predict;
    if (satdir.elev>db->elev_hor) do_predict=0;  

    if (do_predict)
    {
      if (db->next_sat) db->sat_sel=db->next_sat;
      select_this_sat(db->sat_sel);
      report_nextpass(wnd,sat);
    }
    if (satdir.elev<db->elev_hor) do_predict=1;    // next time predict will be done
                                                   // (1 step delay for detection going down correctly)
  }
}
