/*
oud: gtk_timeout_add ==> repeated_calc ==> gmtime2adjust ==> Set_Adjust ==> time_callback ==> idle_func ==>do_onepos_all

nw:  gtk_timeout_add ==> repeated_calc
*/
#include "xtrack.h"
#include "xtrack_func.h"
#include <ctype.h>
#include <stdlib.h>
#include "defines.h"

#include "rs232.h"
extern DBASE *db;

int RS232_Open_Close(int doe_open,int portnr,int speed)
{
  static int is_open;
  if (doe_open>0)
  {
    if (!is_open)
    {
      if (!(RS232_OpenComport(portnr, speed)))
      {
        is_open=1;
      }
    }
    else
    {
      // al open, doe niets
    }
  }
  else if (doe_open<0)
  {
    return is_open;
  }
  else
  {
    if (is_open)
    {
      RS232_CloseComport(portnr);
      is_open=0;
    }
    else
    {
      // was al dicht, doe niets
    }
  }
  return is_open;
}

// __linux__ is al gedef. op linux-bak
//#if __GTK_WIN32__ == 1
//#else
//#define __linux__
//#endif

#define nint(f) (int)((f)+0.5)
static void load_cmd(char *prog,char *frmt,int ew,float azim,float elev)
{
  int n=0,m=0;
  char *p;
  char df='d';
  
  if (strchr(frmt,'f')) df='f';

  for (p=frmt; *p; p++)
  {
    if (*p=='%')
    {
      n++;
    }
  }

  for (p=frmt; *p; p++)
  {
    if (*p=='%')
    {
      m++;
    }
    if (m>=1)
    {
      if ((n==3) && (m==1))
      {
        if (strchr("df",*p)) *p='d';
      }
      else
      {
        if (strchr("df",*p)) *p=df;
      }
    }
  }

//printf("AA: >%s<  %f  %f\n",frmt,azim,elev);
//printf(frmt,1,azim,elev);
  if (n==3)
  {
    if (df=='f')
    {
      sprintf(prog,frmt,ew,azim,elev);
    }
    else
    {
      sprintf(prog,frmt,ew,nint(azim),nint(elev));
    }
  }
  else
  {
    if (df=='f')
      sprintf(prog,frmt,azim,elev);
    else
      sprintf(prog,frmt,nint(azim),nint(elev));
  }
  if (!strcmp(prog+strlen(prog)-2,"\\r"))      sprintf(prog+strlen(prog)-2,"%c",'\r');
  else if (!strcmp(prog+strlen(prog)-2,"\\n")) sprintf(prog+strlen(prog)-2,"%c",'\n');
  else                                         strcat(prog,"\n");
}


static void rs232_onepos(struct tm cur_tm,SAT *sat,GtkWidget *wnd)
{
  DIRECTION satdir=sat->dir;
  char prog[100];
  if ((sat->max_elev) && (sat->max_elev<db->elev_det)) return;
  if (db->to_serial)
  {
    static int op;
    float d1,d2;
    if (satdir.elev>=db->elev_hor)
    {
      op=1;
      if (db->use_xy)
      {
        d1=R2D(satdir.x);
        d2=R2D(satdir.y);
      }
      else
      {
        d1=R2D(satdir.azim);
        d2=R2D(satdir.elev);
      }
    }
    else
    {
      if (db->use_xy)
      {
        d1=90.;         //  elevation 0 = vertical
        d2=90.;         //  elevation 0 = vertical
      }
      else
      {
        d1=0.;
        d2=90.;        //  elevation 90 = vertical
      }
    }
    load_cmd(prog,db->rs232.command,sat->pass_e1_w0,d1,d2);
    if (op)
    {
      char cmd2[100];
      strcpy(cmd2,prog); if (cmd2[strlen(cmd2)-1]=='\n') strcpy(cmd2+strlen(prog)-1,"\\n");
      Set_Entry(Find_Window(wnd,Lab_WNDDebug),LAB_RS232CMD,cmd2);
      if (RS232_Open_Close(-1,0, 0))
        RS232_SendBuf(db->rs232.portnr, (unsigned char*)prog, strlen(prog));
    }
    if (satdir.elev<db->elev_hor) op=0;

  }
}

static char *type_prcnt(char *p)
{
  while ((*p) && ((isdigit(*p)) || (*p=='.'))) p++;
  return p;
}


static void fillin_satpos(char *frmt,char *name,float elev,float azim,float x,float y)
{
  char *p;
  char *rslt=malloc(strlen(frmt)+strlen(name)+50);
  for (p=frmt; *p; p++) if (*p=='%')
  {
    if (*(p+1)=='%')
    {
      p+=2; continue;
    }

    *p=1;
    
  }
  while ((p=strchr(frmt,1)))
  {
    *p='%';
    if ((p=type_prcnt(p+1)))
    {
      switch(*p)
      {
        case 'n': 
          *p='s';
          sprintf(rslt,frmt,name);
          strcpy(frmt,rslt);
        break;
        case 'e': 
          *p='f';
          sprintf(rslt,frmt,elev);
          strcpy(frmt,rslt);
        break;
        case 'a': 
          *p='f';
          sprintf(rslt,frmt,azim);
          strcpy(frmt,rslt);
        break;
        case 'x': 
          *p='f';
          sprintf(rslt,frmt,x);
          strcpy(frmt,rslt);
        break;
        case 'y': 
          *p='f';
          sprintf(rslt,frmt,y);
          strcpy(frmt,rslt);
        break;
        default:
        break;
      }
    }
  }
  free(rslt);
}

static void extprog(SAT *sat)
{
  DIRECTION satdir=sat->dir;
  char prog[100];
#define GOING_UP   ((prev_elev<db->elev_hor) && (satdir.elev>=db->elev_hor))
#define GOING_DOWN ((prev_elev>=db->elev_hor) && (satdir.elev<db->elev_hor))
  static float prev_elev;
  if ((sat->max_elev) && (sat->max_elev<db->elev_det)) return; // skip output
  if ((db->out_on) && (db->ext_on))
  {
    if (*db->prog_track)
    {
      strcpy(prog,db->prog_track);
      fillin_satpos(prog,sat->satname,R2D(satdir.elev),R2D(satdir.azim),R2D(satdir.x),R2D(satdir.y));
      system(prog);
    }
    if ((*db->prog_trackup) && (satdir.elev>=db->elev_hor))
    {
      strcpy(prog,db->prog_trackup);
      fillin_satpos(prog,sat->satname,R2D(satdir.elev),R2D(satdir.azim),R2D(satdir.x),R2D(satdir.y));
      system(prog);
    }
    if ((*db->prog_up) && (GOING_UP))
    {
      strcpy(prog,db->prog_up);
      fillin_satpos(prog,sat->satname,R2D(satdir.elev),R2D(satdir.azim),R2D(satdir.x),R2D(satdir.y));
      system(prog);
    }
    if ((*db->prog_down) && (GOING_DOWN))
    {
      strcpy(prog,db->prog_down);
      fillin_satpos(prog,sat->satname,R2D(satdir.elev),R2D(satdir.azim),R2D(satdir.x),R2D(satdir.y));
      system(prog);
    }
  }
  prev_elev=satdir.elev;

}



static void do_onepos(struct tm cur_tm,int ds,GtkWidget *wnd,SAT *sat)
{
  EPOINT pos_subsat;
  EPOINT pos_sat;
  EPOINT pos_earth;
  DIRECTION satdir;
  int ms_offset=1000.*(db->time_offset_sec-(int)db->time_offset_sec)+100*ds;
  if ((!sat->visible) && (!sat->selected)) return;
  sat->orbit.scan_hor=E_W;

  calc_satpos(cur_tm,&pos_subsat,&satdir,&db->refpos,sat,db->x_at_disc);

  sat->pos.lon=pos_subsat.lon;
  sat->pos.lat=pos_subsat.lat;
  sat->dir.elev=satdir.elev;
  sat->dir.azim=satdir.azim;
  sat->dir.x=satdir.x;
  sat->dir.y=satdir.y;

  if (sat->selected)
  {
    static int do_predict;
    Set_Entry(wnd,LON,"%.1f",R2D(pos_subsat.lon));
    Set_Entry(wnd,LAT,"%.1f",R2D(pos_subsat.lat));
    Set_Entry(wnd,ELE,"%.1f",R2D(satdir.elev));
    Set_Entry(wnd,AZI,"%.1f",R2D(satdir.azim));
    Set_Entry(wnd,XXX,"%.1f",R2D(satdir.x));
    Set_Entry(wnd,YYY,"%.1f",R2D(satdir.y));
  }

  if (sat->type==satellite)
  {
    draw_onepos(cur_tm,wnd,sat,pos_subsat,pos_earth);
  }
  else if (sat->type==sun)
  {
    draw_mark(wnd,pos_subsat,'c',NULL);
//    draw_vis(wnd,sat,&pos_subsat,TRUE);
  }
  else
  {
    draw_mark(wnd,pos_subsat,'C',NULL);
  }

  if (sat->selected)
  {
    rs232_onepos(cur_tm,sat,wnd);
    extprog(sat);
  }
}


void do_onepos_all(GtkWidget *wnd)
{
  SAT *sat;
  if (db->redraw) return;
  do_onepos(db->glob_tm,db->glob_ds,wnd,db->sat);
  clear_wnd(wnd); // achtegrond opnieuw schrjven
  for (sat=db->sat; sat; sat=sat->next)
  {
    do_onepos(db->glob_tm,db->glob_ds,wnd,sat);
  }
  refresh_wnd(wnd);
}
